﻿using System;
//using SDX.Compiler;
//using Mono.Cecil;
//using Mono.Cecil.Cil;
using System.Linq;
using System.Xml;
using System.Collections.Generic;
using UnityEngine;

public static class MinWellnessZeroDeadMode
{

    public static void ExecDeadMode(EntityPlayer entityPlayer, byte deadMode, float modifyedwellness)
    {
        switch (deadMode)
        {
            case 0://normal 
                entityPlayer.Stats.Wellness.Value = Mathf.Max(entityPlayer.Stats.Wellness.Value,modifyedwellness);
                break;
            case 1://wellness less than MinWellness
                if (modifyedwellness > entityPlayer.Stats.Wellness.Value)
                {
                    SetGameOver(entityPlayer);
                }
                else
                {
                    entityPlayer.Stats.Wellness.Value = Mathf.Max(entityPlayer.Stats.Wellness.Value, modifyedwellness);
                }
                break;
            case 2://dead is dead
                if (modifyedwellness > entityPlayer.Stats.Wellness.Value)
                {
                    SetGameOver(entityPlayer);
                }
                else
                {
                    entityPlayer.Stats.Wellness.Value = Mathf.Max(entityPlayer.Stats.Wellness.Value, modifyedwellness);
                }
                break;
        }
    }
    public static void SetGameOver(EntityPlayer entityPlayer)
    {
        entityPlayer.Stats.Wellness.Value = 0f;
        entityPlayer.Stats.Health.OriginalMax = 0f;
        entityPlayer.Stats.Health.Value = 0f;
        entityPlayer.Stats.Stamina.OriginalMax = 0f;
        entityPlayer.Stats.Stamina.Value = 0f;

    }


    public static void ExecDeadMode2(EntityAlive entityAlive,byte deadMode,float oldwellness)
    {
        switch(deadMode)
        {
            case 0://normal 
                break;
            case 1://wellness less than MinWellness
//                if (oldwellness < entityAlive.Stats.Wellness.Value || oldwellness == 0 || entityAlive.Stats.Wellness.Value == 0)
                if (oldwellness < entityAlive.Stats.Wellness.Value || oldwellness == 0)
                {
                    SetGameOver2(entityAlive);
                }
                break;
            case 2://dead is dead
                if (oldwellness != 1000f)
                {
                    SetGameOver2(entityAlive);
                }
                break;
        }
    }
    public static void SetGameOver2(EntityAlive entityAlive)
    {
        entityAlive.Stats.Wellness.Value = 0f;
        entityAlive.Stats.Health.OriginalMax = 0f;
        entityAlive.Stats.Health.Value = 0f;
        entityAlive.Stats.Stamina.OriginalMax = 0f;
        entityAlive.Stats.Stamina.Value = 0f;

    }
   
    public static void SetAddAttribute(XmlElement element, ref byte gameovermode)
    {
        if (element.HasAttribute("GameOverMode"))
        {
            gameovermode = byte.Parse(element.GetAttribute("GameOverMode"));
        }
        else
        {
            gameovermode = 0;
        }
    }

}
